#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void gnome_sort(int *a, int n)
{
  int i=1, j=2, t;
	#define swap(i, j) { t = a[i]; a[i] = a[j]; a[j] = t; } 
  while(i < n) {
    if (a[i - 1] > a[i]) {
      swap(i - 1, i);
      if (--i) continue;
    }
    i = j++;
  }
	#undef swap
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	gnome_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}